
#ifndef _STDLIB_H
#include <stdlib.h>
#endif

#define DESYNC_ALL 1
#define DESYNC_SERV 0


#define TALK_SERVER 1
#define TALK_CLIENT 2

#define QUIETLY 1
#define BRUTE 0

#define HJK_ANY 0

#ifndef u_long
#define u_long unsigned long
#endif
#ifndef u_short
#define u_short unsigned short
#endif
#ifndef u_char
#define u_char unsigned char
#endif

struct hi {
   u_long addr;
   u_short port;
   u_long seq;
   u_long exp_seq;  /* expected sequence number ! */
};

struct hjk_buf{
   char *buf_ptr;
   unsigned short len;
};


struct connection{
   u_short index;
   struct hi src;
   struct hi dst;
   u_char hijacked; /* 1 if this connection is owned */
   u_char serv_hijack; /* 1 if this is owned and we talk with the server ! */
   u_char send_fin;
   u_char no_ack_server;
   struct hjk_buf h_buf;
   struct connection *nxt;
   struct connection *prv;
};

struct binded_port{
   u_short port;
   u_long destaddr;
   void *handler[10];
   int hn;
   u_short dblhjk;
   struct binded_port *nxt;
   struct binded_port *prv;
};

typedef struct connection * hs;
typedef struct binded_port * hb;
